%%%%%%%% Parametric Dictionary Design using SVD and %%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%   gradient descent method in the dictionary domain  %%%%%%%%%%%%%
function ParamDDsvd(pit,bs,RR)
maxNumCompThreads(1)
PIT = str2num(pit);
Rr = str2num(RR);
load(['gammaChirp',bs,'v2.mat'])
%%%%
R = 2;
M = R*N;
P = 5;
Dm = zeros(N,M);
Dpm = zeros(P,M);
Gerr = zeros(PIT,M);
AAg = zeros(N,PIT);
A = D;
[U,So,V] = svd(A,0);
S = So;
G = A'*A;
Gm = G;
Tr = sqrt((M-N)/(N*(M-1)));
for pit = 1:PIT
    pit
%     tic
    %%% Initialization %%%
    if pit ==1
        Gm = G;
        Dm = D;
        Dpm = Dp;
    end
    %%% Projection onto Lambda^N and relaxation with Rr (alpha) %%%
    for i = 1:M
        [Y,Int] = sort(abs(Gm(i,:)),'descend');     
        Babelm(i) = sum(abs(Y(2)));         
        if Babelm(i)> Tr
            for j = i+1:M
                if (abs(Gm(i,j))>Tr), 
                    Gm(i,j) = (Rr*(abs(Gm(i,j))-Tr)+Tr)*sign(Gm(i,j)); 
                end
                Gm(:,i) = Gm(i,:);
            end
        end
    end
    %%% Projecting onto the space of rank-N matrices    
    [Vg,Eg] = eig(Gm);
    Eg1 = Eg;
    Egr1 = zeros(N);    
    Vgr1 = zeros(M,N);
    ind = 1;
    while ind<=N 
        k = 1;
        if abs(Eg(M+1-ind,M+1-ind)-Eg(M+1-ind-k,M+1-ind-k))>.0001
            I = M+1-ind; 
            Egr1(ind,ind) = sqrt(Eg1(I,I));
            Vgr1(:,ind) = Vg(:,I)*sign(Vg(:,I)'*V(:,ind));
            ind = ind+1;
        else
            k = k+1;
            while abs(Eg(M+1-ind,M+1-ind)-Eg(M+1-ind-k,M+1-ind-k))<.0001
                k = k+1;
            end
            if ind+k>N
                k = N-ind +1;
            end
            %%%%%%%%%%
            I = M+1-ind;
            [Uv,Sv,Vv] = svd(V(:,ind:ind+k-1)'*Vg(:,I:-1:I-k+1),0);
            Vgr1(:,ind:ind+k-1) = Vg(:,I:-1:I-k+1)*Vv*Uv';
            Egr1(ind:ind+k-1,ind:ind+k-1) = sqrt(Eg1(I:-1:I-k+1,I:-1:I-k+1));
            %%%%%%%%%%
            ind = ind+k;
        end
    end
    %%%%%%%%%%%%%%%%%%%%
    Egr2 = Egr1.^2;
    gamma = sum(sum(Egr2))/N - M/N;
    while(abs(gamma)>.0001) %%% Normalizing the eigen value of the rank-N matrix
        Egr2 = Egr2-eye(N)*gamma;
        Egr2  = Egr2.*(Egr2>0);
        gamma = sum(sum(Egr2))/N - M/N;
    end 
    Egr1 = sqrt(Egr2);
    B1 = Egr1*Vgr1';    
    for ind = 1:M %%% normalizing the Sigma*V'
        B1(:,ind) = B1(:,ind)/sqrt(B1(:,ind)'*B1(:,ind));
    end      
    [Um,Sm,Vm] = svd(Dm*B1',0);
    U1 = Um*Vm'; %%% Finding the best rotation
    B = U1*B1;  %%% Finally, Generating a dictionary related to Gm (the relaxed projection onto Lamnbda^N)
    for it = 1:M,       
        y = B(:,it);
        [Dm(:,it),Dpm(:,it)] = gammafit1(y,Dm(:,it),Dpm(:,it),fs); %%% Updating the parameter of each atom
    end     
    Gm = Dm'*Dm;
    [U,S,V] = svd(Dm);
    AAg(:,pit) = sum(S');
    Gerr(pit,:) = sum(Gm.^2);
    Gmp = eye(M) + Tr*(sign(Gm)-eye(M));
    Oerr(pit) = sum(sum((Gm - Gmp).^2));
    save(['DictGamma',num2str(N),'t',num2str(PIT),'alpha',num2str(Rr),'b1a1p00SVDv2.mat'],'AAg','Dm','Dpm','Gerr','Oerr')
%     toc
end